# Dieses Beispielskript geht davon aus, dass Sie einen Dienstanwendungspool mit dem Namen SharePoint Dienste anlegen existiert
Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue

# Passen Sie den Anmeldenamen des Anwendungspoolkontos an und stellen Sie sicher, dass Sie das Konto zuvor in den verwalteten Konten registriert haben
$appPool = New-SPServiceApplicationPool -Name "SharePoint Dienste" -Account "sincdemo\svcspfapsvc"

Start-SPEnterpriseSearchServiceInstance $env:computername 
Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance $env:computername 

# Whlen Sie einen nicht belegten Dienstanwendungsnamen
$serviceAppName = "Suche"

# Sofern Sie die Aufteilung der Pools fr die Verwaltung wnschen, knnen Sie hier alternativ den Anwendungspoolnamen, anstelle des zuvor erstellten definieren
$svcPool = Get-SPServiceApplicationPool $appPool
$adminPool = Get-SPServiceApplicationPool $appPool 

$searchServiceInstance = Get-SPEnterpriseSearchServiceInstance Local 
$searchService = $searchServiceInstance.Service 

$bindings = @("InvokeMethod", "NonPublic", "Instance")  
$types = @([string], [Type], [Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool], [Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool])  
$values = @($serviceAppName, [Microsoft.Office.Server.Search.Administration.SearchServiceApplication], [Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool]$svcPool, [Microsoft.SharePoint.Administration.SPIisWebServiceApplicationPool]$adminPool)  
$methodInfo = $searchService.GetType().GetMethod("CreateApplicationWithDefaultTopology", $bindings, $null, $types, $null)  

# Fr die nachfolgende Arbeitsschritte ist etwas mehr Verarbeitungsszeit erforderlich
$searchServiceApp = $methodInfo.Invoke($searchService, $values) 

$searchProxy = New-SPEnterpriseSearchServiceApplicationProxy -Name "$serviceAppName Proxy" -SearchApplication $searchServiceApp 
$searchServiceApp.Provision()
