#Passen Sie den nachfolgenden Block vor dem Ausfhren Ihren Umstnden entsprechend an.
$App1 = "SP2-2"
$SearchAppPoolName = "SharePoint-SuchApp"
$SearchAppPoolAccountName = "SINCDEMO\SVCSPSuchApp"
$SearchServiceName = "SharePoint-Suche"
$SearchServiceProxyName = "SharePoint-Suche-Proxy"
$DatabaseName = "SP2_Search_AdminDB"
$PrimaryIndexLocation = "E:\Data"
$ReplicaIndexLocation = "F:\Data" 

#Eigentlicher Skriptprozess:
Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue

Write-Host "Schritt 01: Erstelle App-Pool"
$spAppPool = New-SPServiceApplicationPool -Name $SearchAppPoolName -Account $SearchAppPoolAccountName -Verbose

Write-Host "Schritt 02: Starte Suchdienst"
Start-SPEnterpriseSearchServiceInstance $App1 -ErrorAction SilentlyContinue
Start-SPEnterpriseSearchQueryAndSiteSettingsServiceInstance $App1 -ErrorAction SilentlyContinue

Write-Host "Schritt 03: Erstelle Suchdienstanwendung"
$ServiceApplication = New-SPEnterpriseSearchServiceApplication -Partitioned -Name $SearchServiceName -ApplicationPool $spAppPool.Name -DatabaseName $DatabaseName
New-SPEnterpriseSearchServiceApplicationProxy -Name $SearchServiceProxyName -SearchApplication $ServiceApplication 

Write-Host "Schritt 04: Erstelle die Admin-Komponente"
New-SPEnterpriseSearchAdminComponent SearchTopology $clone -SearchServiceInstance $App1SSI 

Write-Host "Schritt 05: Erstelle Content-Processing-Komponente"
New-SPEnterpriseSearchContentProcessingComponent SearchTopology $clone -SearchServiceInstance $App1SSI

Write-Host "Schritt 06: Erstelle WebAnalytics-Komponente"
New-SPEnterpriseSearchAnalyticsProcessingComponent SearchTopology $clone -SearchServiceInstance $App1SSI

Write-Host "Schritt 07: Erstelle Crawl-Komponente"
New-SPEnterpriseSearchCrawlComponent SearchTopology $clone -SearchServiceInstance $App1SSI

Write-Host "Schritt 08: Erstelle Query-Proc-Komponente"
New-SPEnterpriseSearchQueryProcessingComponent SearchTopology $clone -SearchServiceInstance $App1SSI

Write-Host "Schritt 09: Erstelle Suchtopologie"
New-SPEnterpriseSearchIndexComponent SearchTopology $clone -SearchServiceInstance $App1SSI -RootDirectory $PrimaryIndexLocation -IndexPartition 0
New-SPEnterpriseSearchIndexComponent SearchTopology $clone -SearchServiceInstance $App2SSI -RootDirectory $ReplicaIndexLocation -IndexPartition 0
New-SPEnterpriseSearchIndexComponent SearchTopology $clone -SearchServiceInstance $App2SSI -RootDirectory $PrimaryIndexLocation -IndexPartition 1

Write-Host "Schritt 10: Aktiviere Topologie"
$clone.Activate()

$ssa = Get-SPEnterpriseSearchServiceApplication
Get-SPEnterpriseSearchTopology -Active -SearchApplication $ssa

Write-Host "Vorgang ist abgeschlossen"
