Add-PSSnapin Microsoft.SharePoint.PowerShell -ErrorAction SilentlyContinue

$patchfile = Get-ChildItem | where{$_.Extension -eq ".exe"} 
  if($patchfile -eq $null) 
  { 
   Write-Host "Keine Patch im lokalen Verzeichnis vorhanden - Skript wird beendet" -ForegroundColor Red 
   Return 
  } 

  $srchctr = 1 
  $srch4srvctr = 1 
  $srch5srvctr = 1 

$srv4 = get-service "OSearch15" 
$srv5 = get-service "SPSearchHostController" 

If(($srv4.status -eq "Running") -or ($srv5.status-eq "Running")) 
  { 
    Write-Host "1 fr pausieren der Suchdienstanwendung" -ForegroundColor Cyan 
    Write-Host "2 fr fortlaufende Suchdienstanwendung" -ForegroundColor Cyan 
    $searchappresult = Read-Host "Geben Sie 1 oder 2 ein und drcken Sie die Eingabetaste"  
    Write-Host 
    if($searchappresult -eq 1) 
    { 
        $srchctr = 2 
        Write-Host "Suchdienstanwendung wird pausiert" -foregroundcolor yellow 
        Write-Host "Dies kann einige Minuten Zeit in Anspruch nehmen" -ForegroundColor Yellow 
        $ssa = get-spenterprisesearchserviceapplication 
        $ssa.pause() 
    } 
    elseif($searchappresult -eq 2) 
    { 
        Write-Host "Fahre fort, ohne die Suchdienstanwendung in den Pausezustand zu versetzen" 
    } 
    else 
    { 
         Write-Host "Fhren Sie das Skript erneut aus und whlen Sie 1 oder 2" -ForegroundColor Red 
        Write-Host "Beende Skript" -ForegroundColor Red 
        Return 
    } 
  } 

Write-Host "Stoppe Suchdienste, sofern diese laufen" -foregroundcolor yellow 
  if($srv4.status -eq "Running") 
  { 
    $srch4srvctr = 2 
    set-service -Name "OSearch15" -startuptype Disabled 
    $srv4.stop() 
  } 

if($srv5.status -eq "Running") 
  { 
    $srch5srvctr = 2 
    Set-service "SPSearchHostController" -startuptype Disabled 
    $srv5.stop() 
  } 

do 
  { 
    $srv6 = get-service "SPSearchHostController" 
    if($srv6.status -eq "Stopped") 
    { 
        $yes = 1 
    } 
    Start-Sleep -seconds 10 
  } 
  until ($yes -eq 1) 

Write-Host "Suchdienste sind gestoppt" -foregroundcolor Green 
  Write-Host 


  Set-Service -Name "IISADMIN" -startuptype Disabled 
  Set-Service -Name "appfabriccachingservice" -startuptype Disabled 
  Set-Service -Name "SPTimerV4" -startuptype Disabled 
  Write-Host "Herunterfahren der IIS W3WP Prozesse" -foregroundcolor yellow 
  Write-Host 
iisreset -stop -noforce 
  Write-Host "Stoppe Dienste" -foregroundcolor yellow 
  Write-Host 

#Gracefull-Stop des verteilten Cache
 $srv1 = get-service "appfabriccachingservice" 
  if($srv1.status -eq "Running") 
  { 
    Write-Host "Herunterfahren des Distributed Caches - diese Operation kann einige Minuten Zeit in Anspruch nehmen" -foregroundcolor Yellow 
    Stop-SPDistributedCacheServiceInstance -Graceful 
    Write-Host "Distributed Cache ist deaktiviert" 
    Write-Host 
  } 

$srv2 = get-service "SPTimerV4" 
  if($srv2.status -eq "Running") 
  {$srv2.stop()} 

Write-Host "Dienste sind gestoppt" -ForegroundColor Green 
  Write-Host 
  Write-Host 

# Patch-Sequenz
  Write-Host "Schlieen Sie keinesfalls das PowerShell-Fenster whrend die Aktualisierung luft!" -ForegroundColor Magenta 
 Write-Host 
 $starttime = Get-Date 

$filename = $patchfile.basename 
 . .\$filename /passive 

Start-Sleep -seconds 20 
 $proc = get-process $filename 
 $proc.WaitForExit() 

$finishtime = get-date 
 Write-Host 
 Write-Host "Aktualisierung wurde fertiggestellt" -foregroundcolor green 
 Write-Host 


# Startsequenz der Dienste
 Write-Host "Starte Dienste" -foregroundcolor yellow 
 Set-Service -Name "appfabriccachingservice" -startuptype Automatic 
 Set-Service -Name "SPTimerV4" -startuptype Automatic 
 Set-Service -Name "IISADMIN" -startuptype Automatic 

 $servername = hostname 
 $server = get-spserver $servername 
 $dcache = Get-SPServiceInstance | where{($_.TypeName -eq "Distributed Cache") -and ($_.Server -eq $server)} 
 if($dcache.status -eq "Disabled") 
  { 
    Write-Host "Starte Distributed Cache" -foregroundcolor "Yellow" 
    $dcache.start() 
  } 

$srv2 = get-service "SPTimerV4" 
 $srv2.start() 
 $srv3 = get-service "IISADMIN" 
 $srv3.start() 
 $srv4 = get-service "OSearch15" 
 $srv5 = get-service "SPSearchHostController" 

 if($srch4srvctr -eq 2) 
 { 
    set-service -Name "OSearch15" -startuptype Automatic 
    $srv4.start() 
 } 
 if($srch5srvctr -eq 2) 
 { 
    Set-service "SPSearchHostController" -startuptype Automatic 
    $srv5.start() 
 } 

 if($srchctr -eq 2) 
 { 
    Write-Host "Suchdienstanwendung wird fortgesetzt" -foregroundcolor yellow 
    $ssa = get-spenterprisesearchserviceapplication 
    $ssa.resume() 
 } 

Write-Host "Dienste wurden gestartet" -foregroundcolor green 
 Write-Host 
 Write-Host "Ausfhrungsstatistik" -foregroundcolor yellow 
 Write-Host "Gestartet: " $starttime -foregroundcolor yellow 
 Write-Host "Beendet: " $finishtime -foregroundcolor yellow 
 