IF OBJECT_ID('tempDB..#index_stats') IS NOT NULL
   drop table #index_stats

Declare @DBname varchar(500),
             @DBID int,
             @sql nvarchar(1000),
             @name varchar(500),
             @ID INT,
             @ParmDefinition nvarchar(500)


Create Table #Index_Stats
(
			 DBName varchar(200),
             Tablename varchar(200),
             Index_Id int, 
             IndexName varchar(250),
             Index_type Varchar(150),
             Alloc_unit_type Varchar(250),
             Is_unique BIT,
             IsXmlIndex BIT,
             IsSpatialIndex Bit,
             avg_fragmentation_in_percent numeric(10,6),
             Fill_factor int,
             Page_count int,
             Insert_Date datetime
)


set @ParmDefinition = N'@name nvarchar(500), @ID INT'

DECLARE index_cursor CURSOR FOR 
SELECT Name, database_id
FROM sys.databases
where name not in ('master','model','msdb','tempdb') 

OPEN index_cursor

FETCH NEXT FROM index_cursor 
INTO @DBName, @DBID

WHILE @@FETCH_STATUS = 0
BEGIN


set @Name = @Dbname
set @ID = @DBID

set @sql = 'Use [' + @name + '] 

insert into #index_stats
SELECT  Case when d.name is null then  @name  
			else d.name 
		end as DBName,
		t.name,
		ps.index_id, 
		i.name,
		ps.index_type_desc,
		ps.alloc_unit_type_desc,
		i.is_unique,
		CAST(case when i.type=3 then 1 else 0 end AS bit) AS [IsXmlIndex],
		CAST(case when i.type=4 then 1 else 0 end AS bit) AS [IsSpatialIndex],
		ps.avg_fragmentation_in_percent,
		i.fill_factor,
		ps.page_count,
		getdate()
 

FROM sys.dm_db_index_physical_stats ( @ID , NULL, NULL, NULL, NULL) AS ps

		INNER JOIN sys.indexes  i 
			ON ps.OBJECT_ID = i.OBJECT_ID
			AND ps.index_id = i.index_id
			and (i.index_id > 0 and i.is_hypothetical = 0)

		INNER JOIN sys.databases d
			ON d.database_id = ps.database_id

        INNER JOIN sys.tables t
			ON t.object_id = ps.object_id

WHERE ps.database_id = @ID 
ORDER BY ps.OBJECT_ID'

--print @sql

Exec sp_executesql @sql,@ParmDefinition,@name = @DBname,@ID=@DBID


FETCH NEXT FROM index_cursor 
INTO @DBName, @DBID

END

CLOSE index_cursor

Deallocate index_cursor

select * from #index_stats
