# Schritt 1: Starten der Suchdienstinstanzen
$hostA = Get-SPEnterpriseSearchServiceInstance -Identity "SP2-1"
$hostB = Get-SPEnterpriseSearchServiceInstance -Identity "SP2-2"
Start-SPEnterpriseSearchServiceInstance -Identity $hostA
Start-SPEnterpriseSearchServiceInstance -Identity $hostB

# Schritt 2: Bindung an Suchdienstanwendung - zu diesem Zeitpunkt mssen die Dienstinstanzen aktiviert sein
$ssa = Get-SPEnterpriseSearchServiceApplication

# Schritt 3: Erstelen einer neuen Topologie
$newTopology = New-SPEnterpriseSearchTopology -SearchApplication $ssa

# Schritt 4: Konfiguration der Topologie
New-SPEnterpriseSearchAdminComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchCrawlComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchContentProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchQueryProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostA
New-SPEnterpriseSearchIndexComponent -SearchTopology $newTopology -SearchServiceInstance $hostA -IndexPartition 0
New-SPEnterpriseSearchAdminComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchCrawlComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchContentProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchAnalyticsProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchQueryProcessingComponent -SearchTopology $newTopology -SearchServiceInstance $hostB
New-SPEnterpriseSearchIndexComponent -SearchTopology $newTopology -SearchServiceInstance $hostB -IndexPartition 0 

# Schritt 5: Anwenden der neuen Topologie
Set-SPEnterpriseSearchTopology -Identity $newTopology

# Schritt 6: Prfung der neuen Topologie
Get-SPEnterpriseSearchTopology -SearchApplication $ssa
Get-SPEnterpriseSearchStatus -SearchApplication $ssa -Text
